/* Space Wars Stage 5. 
   Robert Naugle
   05/02/94 

   This is the main procedure of the Space Wars executable.  It sets the
   initial values of the global variables used through out the code and
   stays in a loop until the simulation is ended by a user presses the escape
   key.

*/
#include "global.h"

/* Future Extensions



   Long range scanner variables all in one struct.
   Dont assume that player number and display number are the same.

     Vdraw should become inline.
        Scaling parameters must be passed to it.
        Do not draw first line.  Only use it as the center point.



   Separate scrolling and border requirements.


   Gravity
    Black hole
      either get sucked in or use thrust to stay still
       bullets bend around it

   

   Keys defined in Xdefaults
   Debris when ships explode.
   Off screen indicatior  (remove if guy is cloaked).
   

   At some angles, Bullets go invisible when drawscale is to small
   When draw scale is big, ship gets hit by own bullet as soon as it is fired.
   
   Game customizations
     Asteriods (are they a separte file?
     Planets
     Bases

   Customize ships.
x    Turret firing
x     Repair rate
x     Hull
x        Change it to an integer.
x        need to keep track of max hull, current hull and repair rate (if any)
  
x     Split shape separate from atributes
x     Separate file for each kind of attributes (weapon, power plant, specials)
x     Default attributes
     Power plant
     Thrust / accelaration / friction?
     Rotation system separate from forward motion
     Ship struct should be an extension of object
       Get rid of all ship info from object.
     Scan other ships
     Lock on a ship

  Damage
x   Give partial damage if shields cannot absorb entire bullet.
   Asteriods need some kind of damage done stored somewhere (ship 0).
       this may be in sw.dat
   Systems relaibilty
x   separate window with damage bars
   Shield and hull damage should be separate
   Sheild should not always absorb all damage when hit hull and systems 
    should also take damage.
   Bigger weapons can destroy bigger asteriods with one shot.
   A collition should do different damage than the bullet.

   Base or fuel asteroid.
    Shoots at other people
    players can control base
    Repairs owners and can fix destroyed systems.

   Teams.
   3d graphics.

   Instant replay.

   GUI for creating ships and systems
   Add a beam weapon
      cannot fire if shield up
      use alot of energy
      always hits if in range.
      limit firing angle
      add lock on and lock on warning
   
   Guided Missile.


   Every action should use energy.

   Should take some damage if hit when shield hit enery is low? 

   shots go through other ships

   Bottom line different for second player

   Ship customization screen.

   May be to many params to collide

  s brings up both ships 

  HELP Screen.

  Multi-player
    All code affected by multi-player will be marked with a #MP
    Get rid of enemy code.
    Get rid of number of ships code
    Need a max player constant.
    Pysical,Device[MAXPLAYERS+1] needs to be though out.
      combine all arrays that depend on a player into one structure.
    player one should have a  value of 0, player 2 with a value of 1
    different ship and object type

  
*/


/* Possible new object type

  shape
  mass
  location (x,y,roataion)
  velocity (x,y,rotation)
  owner
  time
  *move procedure
      calc velocity and damage adj.
      update time and energy
      change picuture
  energy
  shield on
  damage / status % effiecency
     scanners?
     shield
     thrust
     rotation
     hyperspace
     rotation
     weapons
     cloak
     powerplant
     
  cloak on
  mines
  repair rate

*/

Display *dpys[MAXPLAYERS + 1]; 

int SCROLL = 0;
int LASTPLAYER = 1;



/* screen definition */

int letheight   = 20; /* height of font */
int maxbar  =  80;
int barheight = 5;
int rightborder = 200;
int longrangewidth = 200;
int longrangeheight = shipstatusy -1;

int donewship =0,donewgame =0, dopause = 0;

/* Global variables:  */

VirtualType virtual=  {0,0,5000,5000,5001,5001};

PhysicalType   physical[MAXPLAYERS+1] = {{0,0,5001,5001},{0,0,5001,5001},{0,0,5001,5001}};


DeviceType device[MAXPLAYERS+1] = {{550,550,1.0,1.0},{550,550,1.0,1.0},{550,550,1.0,1.0}};

ShipType ship[MAXPLAYERS+1];



Objtype obj[LASTOBJ+1];
/*  In shapes pairs, 1st # is radians, 2nd is length in pixels.
  Degrees: 0 ->, pi/2 down, pi <-, 3*pi/2 up
  IF YOU CHANGE THE SHAPES, you MUST change numpairs & shapesize
*/
/* Define the shape of the large, medium and small asteroids, and bullets */
PolarPair shapes[LASTSHAPE+1][MAXPAIRS] =
	{	{{0,0}, {3*pi/2,40}, {0,20}, {pi/4,28}, {pi/2,40}, /* just crossed 0-deg line */
		 {3*pi/4,28},{pi,40},{5*pi/4,28},{3*pi/2,40},{7*pi/4,28},{0,20}},

    {{0,0}, {3*pi/2,20}, {0,10}, {pi/4,14}, {pi/2,20},
     {3*pi/4,14},{pi,20},{5*pi/4,14},{3*pi/2,20},{7*pi/4,14},{0,10}},

    {{0,0}, {3*pi/2,10}, {0,5}, {pi/4,7}, {pi/2,10},
     {3*pi/4,7},{pi,10},{5*pi/4,7},{3*pi/2,10},{7*pi/4,7},{0,5}},

    {{0,0}, {7*pi/4, 4}, {pi/4, 4}, {3*pi/4, 4}, {5*pi/4, 4}},
/* bullet */
    {{0,0}, {0,10}},

    {{0,0}, {5*pi/4,28}, {0,20}, {pi/4,28},{3*pi/4,28},{pi,20},{7*pi/4,28}},  /* Ship */
    {{0,0}, {5*pi/4,28}, {0,20}, {pi/4,28},{3*pi/4,28},{pi,20},
     {7*pi/4,28}, {3*pi/4, 7}, {9*pi/8, 13}, {15*pi/8, 13}},  /* Thrusting ship */
    {{0,0}, {pi,20},{7*pi/4,28},{pi/4,28},{pi,20}},
    {{0,0}, {5*pi/4,28}, {0,20}, {pi/4,18},{0,10}, {pi/2,15}, {pi,10}, 
                 {3*pi/4,18},{pi,20},{7*pi/4,28}},  /* ship2 */
    {{0,0}, {5*pi/4,28}, {0,20}, {pi/4,18},{0,10},{pi/2,15}, {pi,10}, {3*pi/4,18},
                 {pi,20}, {7*pi/4,28}, {3*pi/4, 7}, {9*pi/8, 13}, {15*pi/8, 13}}  /* Thrusting ship2 */
  };


Boom  blist = NULL;
double  speedscale = 1;
int endgame =0,counterstart = 1,
  NUMPLANETS,
  highscore = 0,
  nextbul = FBUL,     /* Obj# of next bullet fired  */
  numasts,
  rndint = 73, 
  numpairs[LASTSHAPE+1] = {11, 11, 11, 5, 2, 7, 10, 5, 10,         13},
  shapesize[LASTSHAPE+1]  = {44, 21, 10, 2, 1, DEFAULTSHIPSIZE + 1, 35, 20,
                            DEFAULTSHIPSIZE +1, 35 };


main(argc, argv)
     int argc;
     char *argv[];

{

        
  Xparam xdisplay[MAXPLAYERS+1];
  XEvent event;


  extern double speedscale;
  extern int numasts, rndint, score, oldscore,NUMPLANETS;
  extern Objtype obj[LASTOBJ+1];
  extern PhysicalType physical[MAXPLAYERS+1];
  extern height,endgame;
  unsigned char c;  /* for rand */
  double  dx, dy, dist;
  int player = 1,sys;
  int  delay = 64,repaircounter = 0,
       counter,
      i,  /* index for drawing objs, counting bullets */
      r;  /* radius of shield circle  */


  /* echo command line */
  for ( i =1; i < argc; i++)
    printf("%s%s",argv[i],(i < argc-1) ? " " : "");
  printf("\n");

  getdefaults();


  /*DD  printf(" player 2 bulletduration %i\n",ship[2].bulletduration); */

  for (player = FIRSTPLAYER ; player <= LASTPLAYER; player++){

    xdisplay[player] = (Xparam) malloc(sizeof(struct _Xparam));
    if (player == FIRSTPLAYER | player > argc) {
      xdisplay[player]->disp = XOpenDisplay(0);

    }
    else {
      xdisplay[player]->disp = XOpenDisplay(argv[player-FIRSTPLAYER]);
    }
    if (xdisplay[player]->disp == (Display *) NULL){
      fprintf(stderr, "Could not open display\n");
      exit(1);
    }


    initialize(xdisplay[player],player);



    dpys[player-FIRSTPLAYER] = xdisplay[player]->disp;

    ship[player].kills = 0;
    ship[player].killed = 0;
  }

/*  Can delete next line if it causes trouble */
  srand((unsigned) time(0));  /* By Craig Smith */

  initobj(); 


Newgame:
  donewgame = 0;

  deletebooms();

  makeasts(NUMPLANETS);

/*# may have to make new ship a procedure*/
Newship:
    donewship = 0;

  for (player = FIRSTPLAYER; player <= LASTPLAYER; player++) {
    if (!obj[player].alive) {


      obj[player].x = (double)random()/(double)INT_MAX * virtual.x2;
      obj[player].y = (double)random()/(double)INT_MAX * virtual.y2;
      obj[player].xvel = 0;
      obj[player].yvel = 0;
      obj[player].rot = 3*pi/2;
      obj[player].rotvel = 0;
      obj[player].energy = ship[player].initialenergy;
      ship[player].shield_on = 0;
      ship[player].cloak_on = 0;
      ship[player].scannedship = NOSHIP;
      obj[player].blowingup = 0;

      obj[player].owner = player;
        
      for (sys = 0 ; sys < NUMSYSTEMS; sys++) {
        ship[player].system[sys].hitpoints = 
          ship[player].system[sys].maxhitpoints; 
        ship[player].system[sys].repaircounter = 0;
      }


      UpdateSystemStatus(player);

      obj[player].alive = 1;
    }/*end if player not alive*/
    DrawStaticObjects(xdisplay[player],player);

  }/*end player loop*/


  counter = 0;


  while (1) {


    /* Process all events pending on each of the player's displays */
    
    for (player = FIRSTPLAYER; player <= LASTPLAYER; player++) { 
                                                                  
      /*second player loop*/
      while (XEventsQueued(xdisplay[player]->disp, QueuedAfterReading)) {
        XNextEvent(xdisplay[player]->disp, &event);
        ProcessEvent(player,xdisplay[player],event);
        
        if (donewship) goto Newship;
        if (donewgame) goto Newgame;
        if (endgame)     goto End;
      }/*end while events queued loop*/
    }/* end player loop */
    if (!dopause) {
      AdjustShips();
      AdjustComputerControlledShips();
      DrawShortRangeScan (xdisplay); 
      moveobjs();
      repaircounter++;
      if (repaircounter > 2)
        {
          repaircounter = 0;
          DoRepair();
        }
      if (!counter) {
        counter = counterstart; /* Restart counter */
        
      }
      
      counter--;
      for (i = 0; i < delay; i++);
    }/*end if not dopause*/
    
  }
  
 End: 
  
  
  for (player =FIRSTPLAYER ; player <= LASTPLAYER; player++){
    
    Shutdown ( xdisplay[player] );
    
    printf(" player %d, was destroyed %d times and destroyed %d ships. Score: %f \n",player,ship[player].killed,ship[player].kills,
           (float)ship[player].kills/ship[player].killed  );
    
  };
  exit(0);
  


  
}








